## net.sf.saxon.xpath
Class XPathFunctionCall

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.xpath.XPathFunctionCall

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public class XPathFunctionCall

extends FunctionCall

This class is an expression that calls an external function supplied using the JAXP XPathFunction interface

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`XPathFunctionCall(XPathFunction function)` Default constructor

Method Summary
`SequenceIterator` `call(ValueRepresentation[] argValues, XPathContext context)` Call an extension function previously identified using the bind() method.
`void` `checkArguments(StaticContext env)` Method called by the expression parser when all arguments have been supplied
`int` `computeCardinality()` Determine the cardinality of the result
`int` `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the expression, if possible.
`SequenceIterator` `iterate(XPathContext context)` Evaluate the function.
`Expression` `preEvaluate(StaticContext env)` preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)

Methods inherited from class net.sf.saxon.expr.FunctionCall
`display, getArguments, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, optimize, promote, replaceSubExpression, setArguments, setFunctionNameCode, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeSpecialProperties, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathFunctionCall

    public XPathFunctionCall(XPathFunction function)

  Default constructor

Method Detail

### preEvaluate

    public Expression preEvaluate(StaticContext env)

  preEvaluate: this method suppresses compile-time evaluation by doing nothing (because the external function might have side-effects and might use the context)

  Overrides:
    `preEvaluate` in class `FunctionCall`

### checkArguments

    public void checkArguments(StaticContext env)
                        throws XPathException

  Method called by the expression parser when all arguments have been supplied

  Throws:
    `XPathException`

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. XPath external functions are given no access to context information so they cannot have any dependencies on it.

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the function.

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - The context in which the function is to be evaluated
  Returns:
    a Value representing the result of the function.
  Throws:
    `XPathException` - if the function cannot be evaluated.

### call

    public SequenceIterator call(ValueRepresentation[] argValues,
                                 XPathContext context)
                          throws XPathException

  Call an extension function previously identified using the bind() method. A subclass can override this method.

  Parameters:
    `argValues` - The values of the arguments
  Returns:
    The value returned by the extension function
  Throws:
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the expression, if possible. All expressions return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

  This method will always return a result, though it may be the best approximation that is available at the time.

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    the item type

### computeCardinality

    public int computeCardinality()

  Determine the cardinality of the result

  Returns:
    ZERO_OR_MORE (we don't know)

Copyright (C) Michael H. Kay. All rights reserved.